# (C)2018 Ingram Micro Inc. all Rights Reserve
import logging

from sh_base import CleanUpSHBase
from oacleanup.settings import OAModule, CleanUpSteps
from poaupdater import uSysDB

logger = logging.getLogger()

help_link = 'https://kb.odin.com/en/133780'

indicator_services = [
    ('service', 'ApacheNG'),
    ('service', 'ProftpdNG'),
]

WHL_MODULE_NAME = 'WebHosting Linux'


class CleanUpWHL(CleanUpSHBase):
    def __init__(self):
        list_of_available_steps = [
            CleanUpSteps.UNPOVISION_RESOURES,
        ]

        super(CleanUpWHL, self).__init__(
            name=OAModule.WHL,
            list_of_available_steps=list_of_available_steps,
            indicator_services=indicator_services,
            services_to_detach=indicator_services,
            module_services=[],
            help_link=help_link,
        )

    def _unlink_aps_application_from_subscriptions(self, subscription_ids):
        q = """
            UPDATE apache_vdirs SET is_in_use = 'n'
            WHERE homedir_id IN (
                SELECT hd_id FROM domain_services ds
                JOIN services s ON s.service_id = ds.service_id
                WHERE s.name IN %s AND ds.subscription_id IN %s
            )
        """

        con = uSysDB.connect()
        cur = con.cursor()
        cur.execute(q, (tuple([x for _, x in self.indicator_services]), tuple(subscription_ids)))
        con.commit()
